unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient, IdFTPList, IdFTPCommon,
  IdFTP,IdURI, StdCtrls, ComCtrls, DB, ADODB,StrUtils,Contnrs,ftpthread,
  ExtCtrls, Buttons,FtpThread_,IdGlobal;

type
  TForm1 = class(TForm)
    IdFTP1: TIdFTP;
    ListBox1: TListBox;
    ProgressBar1: TProgressBar;
    Label1: TLabel;
    BitBtnStop: TBitBtn;
    BitBtnGetFiles: TBitBtn;
    BitBtnStart: TBitBtn;
    lbtime: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edt_LocalPath: TEdit;
    Edt_ServerPath: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Edt_user: TEdit;
    Edt_pwd: TEdit;
    Edt_FtpIP: TEdit;
    Timer1: TTimer;
    Btn_Down: TBitBtn;
    procedure IdFTP1Status(ASender: TObject; const AStatus: TIdStatus;
      const AStatusText: String);
    procedure IdFTP1WorkEnd(Sender: TObject; AWorkMode: TWorkMode);
    procedure IdFTP1Work(Sender: TObject; AWorkMode: TWorkMode;
      const AWorkCount: Integer);
    procedure IdFTP1WorkBegin(Sender: TObject; AWorkMode: TWorkMode;
      const AWorkCountMax: Integer);
    procedure BitBtnStopClick(Sender: TObject);
    procedure BitBtnGetFilesClick(Sender: TObject);
    procedure BitBtnStartClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Btn_DownClick(Sender: TObject);
  private
    { Private declarations }
    function GetFileNameFromURL(const aURL: string): string;
    procedure doDownload(idftp:TIdFTP;dir: string);
  public
    { Public declarations }
    ThreadState:Boolean;
    ThreadState_:Boolean; 
    procedure searchfile(path:string);
    function  CheckFtpFileExists(const IdFTP:TIdFTP;const fn:string):Boolean;
  end;

var
  Form1: TForm1;
  AbortTransfer:Boolean;
  ftpsend:TFtpThread;
  ftpsend_:TFtpThread_;

implementation

{$R *.dfm}

{ TForm1 }

function TForm1.CheckFtpFileExists(const IdFTP: TIdFTP;
  const fn: string): Boolean;
var
  listFTPFile:TStringList;
begin
  Result := False;
  listFTPFile := TStringList.create;
  try
    try
      IdFTP.List(listFTPFile, ExtractFileName(fn));
    except
    end;
    if(listFTPFile.Count > 0) then
    begin
      Result := True;
     //ShowMessage'ļ' + SFile + '!');
    end;
  finally
    FreeAndNil(listFTPFile );
  end;
end;

function TForm1.GetFileNameFromURL(const aURL: string): string;
var
  ts : TStrings;
begin
  //urlȡļ
  ts := TStringList.create;
  try
    ts.Delimiter :='\';
    ts.DelimitedText := aURL;
    if ts.Count > 0 then
      Result := ts[ts.Count - 1];
  finally
    ts.Free;
  end;
end;

procedure TForm1.IdFTP1Status(ASender: TObject; const AStatus: TIdStatus;
  const AStatusText: String);
var  
  msg:string;  
begin  
  case AStatus of
    hsResolving: msg := 'ڽݡ';
    hsConnecting: msg := 'ӷ';  
    hsConnected: msg := 'ӳɹ';  
    hsDisconnecting: msg := 'ڶϿӡ';  
    hsDisconnected: msg := 'ѶϿ';  
    hsStatusText: msg := 'л״̬';  
    ftpTransfer: msg := 'ڴݡ';  // These are to eliminate the TIdFTPStatus and the  
    ftpReady: msg := 'ɣݴOK';//'׼OK';     // coresponding event  
    ftpAborted: msg := 'ֹ';  
  end;  
  ListBox1.ItemIndex := ListBox1.Items.Add(msg);
end;

procedure TForm1.IdFTP1WorkEnd(Sender: TObject; AWorkMode: TWorkMode);
begin
  if AWorkMode=wmWrite then
  begin  
    if Sender is TIdFTP then
      MessageBox(Handle, 'ݴɣ', 'ϵͳʾ', MB_OK + MB_ICONINFORMATION + MB_TOPMOST);
    ListBox1.Items.Add('ݴɣ');
  end;
end;

procedure TForm1.IdFTP1Work(Sender: TObject; AWorkMode: TWorkMode;
  const AWorkCount: Integer);
begin
  if AbortTransfer then
  begin //ж
    IdFTP1.Disconnect;
    IdFTP1.Abort;
  end;
  ProgressBar1.Position := AWorkCount;
  Application.ProcessMessages;
end;

procedure TForm1.IdFTP1WorkBegin(Sender: TObject; AWorkMode: TWorkMode;
  const AWorkCountMax: Integer);
begin
  AbortTransfer := False;
end;

procedure TForm1.SearchFile(path: string);
var   
  SearchRec:TSearchRec;
  found:integer;
  //aURL, aFile: string;
begin
  found:=FindFirst(path+'\*.*',faAnyFile,SearchRec);
  while    found=0    do
  begin
    if (SearchRec.Name<>'.')  and (SearchRec.Name<>'..') and (SearchRec.Attr<>faDirectory) then
    begin
      ListBox1.Items.Add(SearchRec.Name);

      ////aURL := path+'\'+SearchRec.Name;       //ϴļ·
      ////aFile:= SearchRec.Name;                //õļ
      ////FtpUpLoad(IdFTP1, aURL, aFile, True);  //ļϴ

    end;
    found:=FindNext(SearchRec);
  end;
  FindClose(SearchRec);
end;

procedure TForm1.BitBtnGetFilesClick(Sender: TObject);
var
  tr:Tstrings;
begin
  ListBox1.Items.Clear;
  tr := TStringlist.Create;

  IdFTP1.Host := Edt_FtpIP.Text;
  IdFTP1.Username := Edt_user.Text;
  IdFTP1.Password := Edt_pwd.Text;

  if IdFTP1.Connected then IdFTP1.Disconnect;
    IdFTP1.Connect(); //ӵftp

  IdFTP1.ChangeDir(Edt_ServerPath.Text);    //뵽Ŀ¼
  //IdFTP1.ChangeDir('..');                 //صһĿ¼
  IdFTP1.List(tr);                          //õĿ¼ļб
  ListBox1.Items.Assign(tr);

  tr.Free;
end;

procedure TForm1.BitBtnStartClick(Sender: TObject);
begin
  ListBox1.Items.Clear;
  ftpsend:=TFtpThread.Create(False);
end;

procedure TForm1.BitBtnStopClick(Sender: TObject);
begin
  AbortTransfer := True;
  if ThreadState then
    ftpsend.Suspend;                                                            //̹߳

  if ThreadState_ then
    ftpsend_.Suspend;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  lbtime.Caption:=DateTimeToStr(Now);
end;


procedure TForm1.Btn_DownClick(Sender: TObject);
begin
  ftpsend_:=TFtpThread_.Create(False);
end;

//̵߳ doDownload(IdFTP1,Edt_ServerPath.Text);
procedure TForm1.doDownload(idftp: TIdFTP; dir: string);
var
  t : TIdFTPListItem;
  i : integer;
  fileName,foldName : String;
begin
  //
  form1.IdFTP1.Host     := form1.Edt_FtpIP.Text;
  form1.IdFTP1.Username := form1.Edt_user.Text;
  form1.IdFTP1.Password := form1.Edt_pwd.Text;

  with form1.IdFTP1 do
  try
    if Connected then Disconnect;                      //
      Connect;
  except
    exit;
  end;
  
  if not DirectoryExists(Edt_LocalPath.Text) then     //Ŀ¼򴴽ļ
  begin
    ForceDirectories(Edt_LocalPath.Text);             //һȫ·ļ
  end;
  
  idftp.changedir(Edt_ServerPath.Text);          //ıĿ¼
  idftp.List(nil);                               //ȡǰĿ¼Ϣ
 
  idftp.TransferType := ftBinary;                //ָΪļ   ıļftASCII

  for i:=0 to idftp.DirectoryListing.Count-1 do
  begin
    t := idftp.DirectoryListing.Items[i];        //õһļϢ
    fileName := t.FileName;                      //ȡļ
    if t.ItemType = ditFile then                 //ļֱ
    begin
      form1.ProgressBar1.Max:=IdFTP.Size(t.FileName);
      form1.ListBox1.Items.Add('أļ'+t.FileName+'ļС'+IntToStr(form1.ProgressBar1.Max));
      
      idftp.Get(fileName,Edt_LocalPath.Text+'\' + fileName,True); //صأΪ
    end;
    
    if i=idftp.DirectoryListing.Count-1 then
      form1.ListBox1.Items.Add('**********ļ**********');
  end;
end;

end.
