unit ftpthread;

interface

uses
  Classes,SysUtils,IdFTPCommon,Windows,IdGlobal;

type
  TFtpThread = class(TThread)
  private
    { Private declarations }
  protected
    procedure Execute; override;
    procedure GetParams;
  end;

implementation

uses Unit1;

{ Important: Methods and properties of objects in visual components can only be
  used in a method called using Synchronize, for example,

      Synchronize(UpdateCaption);

  and UpdateCaption could look like,

    procedure TFtpThread.UpdateCaption;
    begin
      Form1.Caption := 'Updated in a thread';
    end; }

{ TFtpThread }

var
  aURL,aFile:string;

procedure TFtpThread.Execute;
var
  i:Byte;
begin
  { Place thread code here }
  Synchronize(GetParams);

  if form1.ListBox1.Items.Count>0 then
  begin
    form1.ThreadState:=True;
    for i:=0 to form1.ListBox1.Items.Count do
    begin
      //ftpʽϴ
      aURL :=form1.Edt_LocalPath.Text+form1.ListBox1.Items.Strings[i];
      aFile:=form1.ListBox1.Items.Strings[i];
      if not FileExists(aURL) then   //ԴļǷ
        Exit;

      form1.ProgressBar1.Max:=FileSizeByName(aURL);
      form1.ListBox1.Items.Add('ļС'+IntToStr(form1.ProgressBar1.Max));
        
      form1.IdFTP1.Host     := form1.Edt_FtpIP.Text;
      form1.IdFTP1.Username := form1.Edt_user.Text;
      form1.IdFTP1.Password := form1.Edt_pwd.Text;

      with form1.IdFTP1 do
      try
        if Connected then Disconnect;          //
           Connect;
      except
        Exit;
      end;

      form1.IdFTP1.TransferType := ftBinary;
      form1.IdFTP1.ChangeDir(form1.Edt_ServerPath.Text);     //ıĿ¼

      if form1.CheckFtpFileExists(form1.IdFTP1,aFile) then       //ϵļǷ
      begin
        //ͬ򲻲
        form1.ProgressBar1.Position:=0;
      end
      else
      begin
        form1.IdFTP1.TransferType := ftBinary;
        try
          form1.IdFTP1.Put(aURL,aFile,False);
        except
          on e:Exception do
          begin
            if e.Message='' then
              MessageBox(0,
                'ʧܣҪϴļСǷ񳬹ƣ',
                'ϵͳʾ', MB_OK + MB_ICONSTOP + MB_TOPMOST)
            else
              MessageBox(0,
                PChar('ʧܣ'+e.Message),
                'ϵͳʾ', MB_OK + MB_ICONSTOP + MB_TOPMOST);
            form1.IdFTP1.Delete(aFile);
          end;
        end;
      end;
    end;
  end;
end;

procedure TFtpThread.GetParams;
begin
  Form1.searchfile(form1.Edt_LocalPath.Text);
end;

end.
